package com.DevAsh.running_apps;
import 	android.app.AppOpsManager;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;
import android.app.Activity;
import android.app.ActivityManager;
import android.app.ActivityManager.RunningAppProcessInfo;
import android.content.ComponentName;
import java.util.ArrayList;
import java.util.List;
import java.io.DataOutputStream;
import android.content.pm.PackageManager;
import android.content.pm.ApplicationInfo;
import android.app.usage.UsageStatsManager;
import java.lang.System;
import 	java.util.Calendar;
import 	android.app.usage.UsageStats;
import android.Manifest;
import android.content.Intent;
import 	android.provider.Settings;



/** RunningAppsPlugin */
public class RunningAppsPlugin implements MethodCallHandler {
  /** Plugin registration. */
  
  Activity activity;
  RunningAppsPlugin(Activity activity){
         this.activity=activity;
  }
  public static void registerWith(Registrar registrar) {
    final MethodChannel channel = new MethodChannel(registrar.messenger(), "running_apps");
    channel.setMethodCallHandler(new RunningAppsPlugin(registrar.activity()));
  }


  public boolean isSTOPPED(ApplicationInfo pkgInfo) {
    System.out.println(pkgInfo.flags & ApplicationInfo.FLAG_STOPPED);
    
    return ((pkgInfo.flags & ApplicationInfo.FLAG_STOPPED) != 0);
  }
  public boolean isSYSTEM(ApplicationInfo pkgInfo) {

    return ((pkgInfo.flags & ApplicationInfo.FLAG_SYSTEM) != 0);
  }

  public  List<String> printForegroundTask() {
    String currentApp = "NULL";

        List<String> running_app = new ArrayList<>();
    
        UsageStatsManager usm = (UsageStatsManager)activity.getSystemService("usagestats");
        long time = System.currentTimeMillis();
        List<UsageStats> appList = usm.queryUsageStats(UsageStatsManager.INTERVAL_DAILY,  time - 1000*1000, time);
       
        
        for(UsageStats i : appList ){
          running_app.add(i.getPackageName());
        }
        return running_app;
  }
             

  

  @Override
  public void onMethodCall(MethodCall call, Result result) {
    if (call.method.equals("getPlatformVersion")) {
      result.success("Android " + android.os.Build.VERSION.RELEASE);


    }else if(call.method.equals("RunningApps")){

      result.success(printForegroundTask());


    }else if(call.method.equals("Getperm")){
      
      Intent usageAccessIntent = new Intent( Settings.ACTION_USAGE_ACCESS_SETTINGS );
      usageAccessIntent.addFlags( Intent.FLAG_ACTIVITY_NEW_TASK );
      activity.startActivity( usageAccessIntent );
      
      

    }
    else {
      result.notImplemented();
    }
  }
}




